/***************************************************************************
****************************************************************************
*   File: \\C2200\Z Drive\Filters\Lowpass_3_kHz.c
*   Created by dsPIC FD Version 2.1.0 Build 1 at 21:17:29 Feb 26 2011
*   C Code Generator - Version 4.0  
****************************************************************************
*  Code Fragment to implement filter
*
*  The functions defined in 'qed_filt.c' must be compiled and linked in.
*    This can be accomplished by either #include "qed_filt.c"
*    or by separately compiling and linking 'qed_filt.c'
*
*** following is actual code fragment
*  extern FIR_filter FIR_Lowpass_3_kHz;
*
*  init_fir_float (&FIR_Lowpass_3_kHz);  // initialize filter structure 
*
*  FIR_Lowpass_3_kHz.filter ( x, y, n, &FIR_Lowpass_3_kHz);  // x is an array of input samples
*                                            // y is an array of output samples
*                                            // n is number of samples to process
*                                            // &FIR_Lowpass_3_kHz is a pointer to the
*                                            //    filter structure
*****************************************************************************
*  This is a complete program which can be compiled and run to test the filter.
*  To change this to a subroutine only, just add in this program or add globally
*     in "qed_cgen.h" the line with the definition of DEFINE_SUBROUTINE as follows
*  #define DEFINE_SUBROUTINE
*****************************************************************************
****************************************************************************/

/* qed_cgen.h contains definitions of filter structures and function prototypes */
#include "qed_cgen.h"

/* filter functions are in files 'qed_filt.c'  */

float Lowpass_3_kHz_coeff[57] = {
   1.922607421875e-003F,  /* filter tap #    0 */
   2.014160156250e-003F,  /* filter tap #    1 */
   1.373291015625e-003F,  /* filter tap #    2 */
   0.000000000000e+000F,  /* filter tap #    3 */
  -1.922607421875e-003F,  /* filter tap #    4 */
  -3.997802734375e-003F,  /* filter tap #    5 */
  -5.493164062500e-003F,  /* filter tap #    6 */
  -5.737304687500e-003F,  /* filter tap #    7 */
  -4.272460937500e-003F,  /* filter tap #    8 */
  -1.007080078125e-003F,  /* filter tap #    9 */
   3.509521484375e-003F,  /* filter tap #   10 */
   8.392333984375e-003F,  /* filter tap #   11 */
   1.211547851563e-002F,  /* filter tap #   12 */
   1.330566406250e-002F,  /* filter tap #   13 */
   1.083374023438e-002F,  /* filter tap #   14 */
   4.455566406250e-003F,  /* filter tap #   15 */
  -5.035400390625e-003F,  /* filter tap #   16 */
  -1.580810546875e-002F,  /* filter tap #   17 */
  -2.511596679688e-002F,  /* filter tap #   18 */
  -2.984619140625e-002F,  /* filter tap #   19 */
  -2.713012695313e-002F,  /* filter tap #   20 */
  -1.519775390625e-002F,  /* filter tap #   21 */
   6.195068359375e-003F,  /* filter tap #   22 */
   3.549194335938e-002F,  /* filter tap #   23 */
   6.936645507813e-002F,  /* filter tap #   24 */
   1.032409667969e-001F,  /* filter tap #   25 */
   1.321411132813e-001F,  /* filter tap #   26 */
   1.515808105469e-001F,  /* filter tap #   27 */
   1.584167480469e-001F,  /* filter tap #   28 */
   1.515808105469e-001F,  /* filter tap #   29 */
   1.321411132813e-001F,  /* filter tap #   30 */
   1.032409667969e-001F,  /* filter tap #   31 */
   6.936645507813e-002F,  /* filter tap #   32 */
   3.549194335938e-002F,  /* filter tap #   33 */
   6.195068359375e-003F,  /* filter tap #   34 */
  -1.519775390625e-002F,  /* filter tap #   35 */
  -2.713012695313e-002F,  /* filter tap #   36 */
  -2.984619140625e-002F,  /* filter tap #   37 */
  -2.511596679688e-002F,  /* filter tap #   38 */
  -1.580810546875e-002F,  /* filter tap #   39 */
  -5.035400390625e-003F,  /* filter tap #   40 */
   4.455566406250e-003F,  /* filter tap #   41 */
   1.083374023438e-002F,  /* filter tap #   42 */
   1.330566406250e-002F,  /* filter tap #   43 */
   1.211547851563e-002F,  /* filter tap #   44 */
   8.392333984375e-003F,  /* filter tap #   45 */
   3.509521484375e-003F,  /* filter tap #   46 */
  -1.007080078125e-003F,  /* filter tap #   47 */
  -4.272460937500e-003F,  /* filter tap #   48 */
  -5.737304687500e-003F,  /* filter tap #   49 */
  -5.493164062500e-003F,  /* filter tap #   50 */
  -3.997802734375e-003F,  /* filter tap #   51 */
  -1.922607421875e-003F,  /* filter tap #   52 */
   0.000000000000e+000F,  /* filter tap #   53 */
   1.373291015625e-003F,  /* filter tap #   54 */
   2.014160156250e-003F,  /* filter tap #   55 */
   1.922607421875e-003F}; /* filter tap #   56 */

float Lowpass_3_kHz_smpl[57];  /* sample delay line */ 

float Lowpass_3_kHz_gain = 1.000000000000e+000F; /* gain multiplier for FIR realization */

FIR_filter FIR_Lowpass_3_kHz = {

     0,     /* quantization: 0 off, 1 on   */
     1,     /* quantization type */
            /*   0  Floating point         */
            /*   1  Fixed point fractional */
     0,     /* quantization type */
            /*   0 - No scaling of filter */
            /*   1 - Center tap scaled to be > 0.5 and < 1.0  */
            /*   2 - Center tap scaled to be 1.0 - gain factor
                     (essentially largest positive value) */
   0,           /* shift count - fixed point fractional */ 
   57,           /* filter length */ 
   0,            /* initial delay line index */
   &Lowpass_3_kHz_gain,  /* ptr to gain value          */
   Lowpass_3_kHz_coeff,  /* ptr to filter coefficients */
   Lowpass_3_kHz_smpl,   /* ptr to delay line */
   fir_float_reg}; /* ptr to filter routine */

/* call the following function first and normally only once */
/* init_fir_float (&FIR_Lowpass_3_kHz)  */
/*   where &FIR_Lowpass_3_kHz is a pointer to the FIR_filter */
/*   structure defining the filter */


/* call the following function to filter n samples */
/* FIR_Lowpass_3_kHz.filter (pIn, pOut, int n, &FIR_Lowpass_3_kHz); */

/*   where pIn  is a pointer to an array or buffer of samples to be filtered */
/*         pOut is a pointer to the array of filtered samples output by the filter */
/*         n    is the number of samples to filter */
/*         &FIR_Lowpass_3_kHz is a pointer to the structure defining the filter */


#ifndef DEFINE_SUBROUTINE

/* The following main program can be used to test the filter.         */
/*   input is in file 'in' and the filtered samples are in file 'out' */
/*   The input and output files are ascii floating point values       */
/*    e.g 1.0342 with 1 sample per line                               */
/* The input files can be created in DSPworks and exported as         */
/*   ascii floating point or any other system capable of creating     */
/*   ascii files with floating point values.                          */
/* The filtered output file can be imported into DSPworks as an ascii */
/*    floating point file and an FFT can be run to validate           */
/*    the frequency response.                                         */

#include "qed_filt.c"
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <math.h>


#define INSZ1  1000
#define OUTSZ1 1000

static    float x[INSZ1], y[OUTSZ1];


int main(int argc, char *argv[])

{
  int i, in_count, file_status, error;

  FILE *fin;              /* input file of samples */
  FILE *fout;             /* output file of filtered samples */ 

  fprintf (stderr," ***** start filter test *****\n");

  fprintf (stderr," this program accepts 0,1 or 2 command line arguments\n");
  fprintf (stderr," the first  argument is the filename of the input file\n");
  fprintf (stderr," the second argument is the filename of the output file\n");
  fprintf (stderr," if there are 0 arguments, input and output is respectively\n");
  fprintf (stderr,"     stdin and stdout\n");
  fprintf (stderr," if only one argument is specified, then output is stdout\n");
  fprintf (stderr," if input is stdin rather than a file, then fscanf expects input\n");
  fprintf (stderr,"     from the console which may be piped in or entered directly\n");

  fin  = stdin;
  fout = stdout;
  error = 0;

  if (argc == 1) {
	    fprintf(stderr," ***** waiting for input *****\n");
  }
  if (argc >= 2) {
      fin = fopen (argv[1], "r");
      if (fin == NULL) {
          fprintf(stderr,"\n error - Cannot open file %s for input\n", argv[1]);
          error = 1;
      }
  }
  if (argc >= 3) {
      fout = fopen (argv[2], "w");
      if (fout == NULL) {
          fprintf(stderr,"\n error - Cannot open file %s for output\n", argv[2]);
          error = 1;
      }
  }
  if (error) {
      fprintf(stderr," ***** end filter test *****\n");
      return(0);
  }
  
  

  init_fir_float (&FIR_Lowpass_3_kHz);


  do {

      /* get input samples */ 
      for (in_count = 0; in_count < INSZ1; in_count++) { 
          file_status = fscanf(fin,"%f",&x[in_count]); 
          if (file_status != 1) 
              break; 
      }

      /* filter samples */ 

      if (in_count == 0) break;

      FIR_Lowpass_3_kHz.filter( x, y, in_count, &FIR_Lowpass_3_kHz);

      for (i = 0; i < in_count; i++)
          fprintf (fout,"%f\n",y[i]);

  } while (file_status == 1);

  fclose (fin); 
  fclose (fout);

  fprintf(stderr," ***** end filter test *****\n");
  return(1);

}
 
#endif 
