#ifndef SSB_2400T_H
#define SSB_2400T_H

void abort(void);
extern FIRStruct SSB_2400TFilter;

#endif /* SSB_2400T_H */

/* The following C-code fragment demonstrates how to call the filter routine
#include "FIR_Filter.h"
#include "SSB_2400T.h"

// NUM_SAMPLES defines the number of samples in one block of input data.
// This value should be changed as needed for the application
#define NUM_SAMPLES 100

{
   // Declare input and output sample arrays.
   int  inSamples[NUM_SAMPLES], outSamples[NUM_SAMPLES];


   // Call the FIRDelayInit routine to zero out the delay line
   FIRFilterInit( &SSB_2400TFilter );

   // Call FIR for each block of input samples
   // This routine would normally be called inside a FOR or a DO-WHILE loop
   // Only one instance has been shown
   FIR( NUM_SAMPLES, &outSamples, &inSamples,  &SSB_2400TFilter,);
}
*/
