void Init_Routine(void);

void Init_Routine (void)
{
unsigned char out_C[4] = "*";
// Setup IO Ports
	ANSELA = 0x0f;
	TRISA = 0xcf;
	PORTAbits.RA5 = 1;
	PORTAbits.RA4 = 0;

	ANSELB = 0x00;
	TRISB = 0xf1;
	PORTB = 0x06;

	ANSELC = 0x00;
	TRISC = 0xf8;
	PORTC = 0x00;

// Setup USART
Open1USART( 	USART_TX_INT_OFF &
				USART_RX_INT_OFF &
				USART_ASYNCH_MODE &
				USART_EIGHT_BIT &
				USART_CONT_RX &
				USART_BRGH_HIGH,
				80 );

	LCD_INIT();
	LO2_INIT();
	Delay10KTCYx(255);
	Delay10KTCYx(255);
	Delay10KTCYx(255);
	Delay10KTCYx(255);
	Delay10KTCYx(255);
	Delay10KTCYx(255);
	EEPROM_Restore();
	Freq_Dial = Band_Offset[Band][A_B[Band]];

	LCD_PUTC(0x01);
	Delay10KTCYx(1);
	LNAset();
	Mode_Set();
	Filter_Set();
	Parm_Set();
	LCD_PUTC(0xc6);
	LCD_PUTD('2');
	LCD_PUTD('5');
	LCD_PUTD('w');
	LCD_PUTD(' ');
	Int_Flag = 1;

	out_C[1] = 'G';
	switch (Parm_Data[2])	
	{
	case 0:
		out_C[2] = 'L';
		break;
	case 1:
		out_C[2] = 'M';
		break;
	case 2:
		out_C[2] = 'H';
		break;
	}
	puts1USART(out_C);

	out_C[1] = 'T';
	out_C[2] = Parm_Data[3] + 48;
	puts1USART(out_C);
	
	OpenADC( ADC_FOSC_32 &
			ADC_RIGHT_JUST &
			ADC_12_TAD,
			ADC_CH2 &
			ADC_INT_OFF, 15 );

// Interrupt Setup
	RCONbits.IPEN = 0;
	IOCB = 0xe0;
	INTCON2bits.RBPU = 0;
	Int_Flag = 0;
	Old_PB = PORTB & 0xe0;
	INTCON2bits.INTEDG0 = 0;
	INTCON = 0x98;
}


