// Scans the Keypad once.
// Returns:
//			0 = No key pressed
//			1 = A<>B
//			2 = A=B
//			3 = FILTER
//			4 = MODE
//			5 = LNA
//			6 = METER
//			7 = BAND
//			8 = LO/HI
//			9 = DIAL
//			10 = RATE
int Read_Keypad(void);

int Read_Keypad(void)
	{
	int c=0;
	PORTD = 0x02;
	Delay10TCYx(1);
	if (PORTAbits.RA6 == 1) c=1;
	if (PORTCbits.RC5 == 1) c=2;

	PORTD = 0x04;
	Delay10TCYx(1);
	if (PORTAbits.RA6 == 1) c=3;
	if (PORTCbits.RC5 == 1) c=4;

	PORTD = 0x08;
	Delay10TCYx(1);
	if (PORTAbits.RA6 == 1) c=5;
	if (PORTCbits.RC5 == 1) c=6;

	PORTD = 0x10;
	Delay10TCYx(1);
	if (PORTAbits.RA6 == 1) c=7;
	if (PORTCbits.RC5 == 1) c=8;

	PORTD = 0x20;
	Delay10TCYx(1);
	if (PORTAbits.RA6 == 1) c=9;
	if (PORTCbits.RC5 == 1) c=10;

	return c;
	}
