; ..............................................................................
;    File   CW_400T.s
; ..............................................................................

		.equ CW_400TNumTaps, 151

; ..............................................................................
; Allocate and initialize filter taps

		.section .CW_400Tconst, code
		.align 512

CW_400TTaps:
.hword 	0x0001,	0x0003,	0xFFFE,	0x0000,	0x0000,	0x0004,	0xFFFE,	0xFFFB,	0x000F
.hword 	0xFFF8,	0xFFF3,	0x0020,	0xFFEE,	0xFFEA,	0x0037,	0xFFDF,	0xFFE1,	0x0051
.hword 	0xFFCD,	0xFFD9,	0x006C,	0xFFB9,	0xFFD4,	0x0083,	0xFFA5,	0xFFD4,	0x0093
.hword 	0xFF96,	0xFFD8,	0x0096,	0xFF91,	0xFFE1,	0x0086,	0xFF9C,	0xFFEE,	0x0061
.hword 	0xFFBD,	0xFFFA,	0x0023,	0xFFFA,	0x0001,	0xFFCC,	0x0055,	0x0002,	0xFF5D
.hword 	0x00D2,	0xFFF6,	0xFEDC,	0x0170,	0xFFD8,	0xFE4F,	0x022B,	0xFFA4,	0xFDBF
.hword 	0x02FC,	0xFF5B,	0xFD37,	0x03D7,	0xFEFC,	0xFCBF,	0x04B2,	0xFE8C,	0xFC62
.hword 	0x057E,	0xFE10,	0xFC25,	0x062F,	0xFD8F,	0xFC0F,	0x06B6,	0xFD14,	0xFC1F
.hword 	0x070C,	0xFCA8,	0xFC53,	0x072A,	0xFC53,	0xFCA8,	0x070C,	0xFC1F,	0xFD14
.hword 	0x06B6,	0xFC0F,	0xFD8F,	0x062F,	0xFC25,	0xFE10,	0x057E,	0xFC62,	0xFE8C
.hword 	0x04B2,	0xFCBF,	0xFEFC,	0x03D7,	0xFD37,	0xFF5B,	0x02FC,	0xFDBF,	0xFFA4
.hword 	0x022B,	0xFE4F,	0xFFD8,	0x0170,	0xFEDC,	0xFFF6,	0x00D2,	0xFF5D,	0x0002
.hword 	0x0055,	0xFFCC,	0x0001,	0xFFFA,	0x0023,	0xFFFA,	0xFFBD,	0x0061,	0xFFEE
.hword 	0xFF9C,	0x0086,	0xFFE1,	0xFF91,	0x0096,	0xFFD8,	0xFF96,	0x0093,	0xFFD4
.hword 	0xFFA5,	0x0083,	0xFFD4,	0xFFB9,	0x006C,	0xFFD9,	0xFFCD,	0x0051,	0xFFE1
.hword 	0xFFDF,	0x0037,	0xFFEA,	0xFFEE,	0x0020,	0xFFF3,	0xFFF8,	0x000F,	0xFFFB
.hword 	0xFFFE,	0x0004,	0x0000,	0x0000,	0xFFFE,	0x0003,	0x0001

; ..............................................................................
; Allocate delay line in (uninitialized) Y data space

		.section .ybss, bss, ymemory
		.align 512

CW_400TDelay:
		.space CW_400TNumTaps*2

; ..............................................................................
; Allocate and intialize filter structure

		.section .data
		.global _CW_400TFilter

_CW_400TFilter:
.hword CW_400TNumTaps
.hword psvoffset(CW_400TTaps)
.hword psvoffset(CW_400TTaps)+CW_400TNumTaps*2-1
.hword psvpage(CW_400TTaps)
.hword CW_400TDelay
.hword CW_400TDelay+CW_400TNumTaps*2-1
.hword CW_400TDelay

; ..............................................................................
; ..............................................................................
; Sample assembly language calling program
;  The following declarations can be cut and pasted as needed into a program
;		.extern	_FIRFilterInit
;		.extern	_FIR
;		.extern	_CW_400TFilter
;
;		.section	.bss
;
;	 The input and output buffers can be made any desired size
;	   the value 40 is just an example - however, one must ensure
;	   that the output buffer is at least as long as the number of samples
;	   to be filtered (parameter 1)
;input:		.space	40
;output:	.space	40
;		.text
;
;
;  This code can be copied and pasted as needed into a program
;
;
; Set up pointers to access input samples, filter taps, delay line and
; output samples.
;		mov	#_CW_400TFilter, W0	; Initalize W0 to filter structure
;		call	_FIRDelayInit	; call this function once
;
; The next 4 instructions are required prior to each subroutine call
; to _FIR
;		mov	#_CW_400TFilter, W3	; Initalize W3 to filter structure
;		mov	#input, W2	; Initalize W2 to input buffer 
;		mov	#output, W1	; Initalize W1 to output buffer
;		mov	#20, W0	; Initialize W0 with number of required output samples
;		call	_FIR	; call as many times as needed
