; ..............................................................................
;    File   Lowpass_3_kHz.s
; ..............................................................................

		.equ Lowpass_3_kHzNumTaps, 33

; ..............................................................................
; Allocate and initialize filter taps

		.section .xdata, data, xmemory
		.align 128

Lowpass_3_kHzTaps:
.hword 	0x0043,	0x00BE,	0x0129,	0x0144,	0x00DB,	0xFFDE,	0xFE77,	0xFD0E,	0xFC3B
.hword 	0xFC98,	0xFE92,	0x023C,	0x0739,	0x0CC1,	0x11CC,	0x1555,	0x1699,	0x1555
.hword 	0x11CC,	0x0CC1,	0x0739,	0x023C,	0xFE92,	0xFC98,	0xFC3B,	0xFD0E,	0xFE77
.hword 	0xFFDE,	0x00DB,	0x0144,	0x0129,	0x00BE,	0x0043

; ..............................................................................
; Allocate delay line in (uninitialized) Y data space

		.section .ybss, bss, ymemory
		.align 128

Lowpass_3_kHzDelay:
		.space Lowpass_3_kHzNumTaps*2

; ..............................................................................
; Allocate and intialize filter structure

		.section .data
		.global _Lowpass_3_kHzFilter

_Lowpass_3_kHzFilter:
.hword Lowpass_3_kHzNumTaps
.hword Lowpass_3_kHzTaps
.hword Lowpass_3_kHzTaps+Lowpass_3_kHzNumTaps*2-1
.hword 0xff00
.hword Lowpass_3_kHzDelay
.hword Lowpass_3_kHzDelay+Lowpass_3_kHzNumTaps*2-1
.hword Lowpass_3_kHzDelay
