void LCD_INIT(void);
void LCD_PUTC (unsigned char C);
void LCD_PUTD(unsigned char C);

void LCD_INIT(void)
	{
	ANSELD = 0x00;
	TRISD = 0x00;
	PORTD = 0x00;

	ANSELE = 0x00;
	TRISE = 0x00;
	PORTE = 0x00;

	Delay10KTCYx(240);
	LCD_PUTC(0x38);
	Delay10KTCYx(80);
	LCD_PUTC(0x0C);
	LCD_PUTC(0x01);
	Delay10KTCYx(1);
	LCD_PUTC(0x06);

	LCD_PUTC(0x40);
	LCD_PUTD(0x00);
	LCD_PUTD(0x00);
	LCD_PUTD(0x18);
	LCD_PUTD(0x18);
	LCD_PUTD(0x18);
	LCD_PUTD(0x18);
	LCD_PUTD(0x00);
	LCD_PUTD(0x00);

	LCD_PUTD(0x00);
	LCD_PUTD(0x00);
	LCD_PUTD(0x1b);
	LCD_PUTD(0x1b);
	LCD_PUTD(0x1b);
	LCD_PUTD(0x1b);
	LCD_PUTD(0x00);
	LCD_PUTD(0x00);

	LCD_PUTD(0x00);
	LCD_PUTD(0x18);
	LCD_PUTD(0x18);
	LCD_PUTD(0x18);
	LCD_PUTD(0x18);
	LCD_PUTD(0x18);
	LCD_PUTD(0x18);
	LCD_PUTD(0x00);

	LCD_PUTD(0x00);
	LCD_PUTD(0x1b);
	LCD_PUTD(0x1b);
	LCD_PUTD(0x1b);
	LCD_PUTD(0x1b);
	LCD_PUTD(0x1b);
	LCD_PUTD(0x1b);
	LCD_PUTD(0x00);

	LCD_PUTD(0x00);
	LCD_PUTD(0x1F);
	LCD_PUTD(0x11);
	LCD_PUTD(0x11);
	LCD_PUTD(0x11);
	LCD_PUTD(0x11);
	LCD_PUTD(0x1F);
	LCD_PUTD(0x00);

	LCD_PUTD(0x00);
	LCD_PUTD(0x1F);
	LCD_PUTD(0x1F);
	LCD_PUTD(0x1F);
	LCD_PUTD(0x1F);
	LCD_PUTD(0x1F);
	LCD_PUTD(0x1F);
	LCD_PUTD(0x00);

	LCD_PUTD(0x04);
	LCD_PUTD(0x0e);
	LCD_PUTD(0x15);
	LCD_PUTD(0x04);
	LCD_PUTD(0x04);
	LCD_PUTD(0x04);
	LCD_PUTD(0x04);
	LCD_PUTD(0x00);

	LCD_PUTD(0x04);
	LCD_PUTD(0x04);
	LCD_PUTD(0x04);
	LCD_PUTD(0x04);
	LCD_PUTD(0x15);
	LCD_PUTD(0x0e);
	LCD_PUTD(0x04);
	LCD_PUTD(0x00);


 	LCD_PUTC(0x80);
	LCD_PUTD('D');
	LCD_PUTD('S');
	LCD_PUTD('P');
	LCD_PUTD('-');
	LCD_PUTD('6');
	LCD_PUTD('1');
	LCD_PUTD('0');
 	LCD_PUTC(0x8E);
	LCD_PUTD('W');
	LCD_PUTD('A');
	LCD_PUTD('2');
	LCD_PUTD('E');
	LCD_PUTD('U');
	LCD_PUTD('J');
	}

void LCD_PUTC (unsigned char C)
	{
	char T;
	T =INTCONbits.GIE;
	PORTD = C;
	Delay10TCYx(10);
	PORTE = 0x01;
	Delay10TCYx(10);
	PORTE = 0x00;
	Delay10TCYx(5);
	INTCONbits.GIE = T;
	}

void LCD_PUTD(unsigned char C)
	{
	char T;
	T =INTCONbits.GIE;
	PORTD = C;
	PORTE = 0x04;
	Delay10TCYx(10);
	PORTE = 0x05;
	Delay10TCYx(10);
	PORTE = 0x00;
	Delay10TCYx(5);
	INTCONbits.GIE = T;
	}
